<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object 		
	protected $obj_course;
	protected $obj_registrasi;
	protected $obj_notify;
	private $obj_upload;
	// init variable
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tersedia');	
	}
	
	protected function PageLoad(){ 
		// load business
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		$this->obj_registrasi = $this->obj_ctrl->LoadBusiness('registrasi', 'mysql', $this->arr_config['db']);
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');

		// load library
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'normal_search':
				self::NormalSearch();
				break;
			case 'registrasi':
				self::Registrasi();
				break;
			case 'reset':
				self::ResetSession();
				break;	
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	private function NormalSearch(){
		$int_month_1 = $this->arr_params['month_1'];
		$int_month_2 = $this->arr_params['month_2'];
		$int_year = $this->arr_params['year'];
		$str_kota = $this->arr_params['kota'];
		if(isset($this->arr_params['tempat'])){
			$_SESSION['search']['course']['tempat'] =  $this->arr_params['tempat'];
		}
		if(isset($this->arr_params['kapasitas'])){
			$_SESSION['search']['course']['kapasitas'] =  $this->arr_params['kapasitas'];
		}
		
		$kota = $this->obj_registrasi->GetDataAsSingleArray('GetIdCityByName', array($str_kota));
		if(!empty($int_month_1) && !empty($int_month_2) && !empty($int_year) && !empty($str_kota)){
			// redirect url
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tersedia', array($int_month_1, $int_month_2, $int_year, $kota['id_city']));	
		}else if(!empty($int_month_1) && !empty($int_month_2) && !empty($int_year)){
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tersedia', array($int_month_1, $int_month_2, $int_year));	
		}else{
			// redirect url
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'],'tersedia');	
		}
	}
	
	private function Registrasi(){	
		//print_r($this->arr_params['id_person']);exit;
		// inisialize variable --------------------------------------------
		$err = array();		
		//$filled = array();
		// required -------------------------------------------
		
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Nama lengkap</strong> harus diisi'; }
		if(empty($this->arr_params['id_corse'])){ $err[] = '<br /><strong>Tempat lahir</strong> harus diisi'; }
		//if(empty($this->arr_params['ukuran'])){ $err[] = '<br /><strong>Alamat</strong> harus diisi'; }
		$cek_kepesertaan = $this->obj_course->GetDataAsSingleArray("GetPesertaByPerson",array($this->arr_params['id_person'],$this->arr_params['id_corse']));
		//print_r($cek_kepesertaan);exit;
		if(!empty($cek_kepesertaan['id_person'])){ $err[] = '<br /><strong>Anda Sudah Terdaftar</strong> Sebagai Peserta'; }
		// id city
		/*$kota = $this->obj_cv->GetIdCityByName(array(trim($this->arr_params['kota'])));
		if(empty($kota)){ $err[] = '<br /><strong>Data kota</strong> tidak ditemukan'; }*/
		// processing -----------------------------------------------------
		if(empty($err)){
			$tgl_bayar = $this->arr_params['tahun_bayar']."-".$this->arr_params['bulan_bayar']."-".$this->arr_params['hari_bayar'];

			$berkas = $_FILES['file_attach'];
			$id = $this->obj_course->GetLastIdPeserta(array());	
			$file_name = str_replace(' ', '_', $berkas['name']);
			$file_path = "doc/karya_ilmiah/".$id."/";
			
			$params = array($this->arr_params['id_person'], 
							$this->arr_params['id_corse'],  
							$this->arr_params['baju'], 
							$this->arr_params['utusan'], 
							$file_name,
							$file_path,
							$this->str_userid);
			// execute process
			//$this->obj_course->DebugQuery("InsertPeserta",$params);exit;
			if($this->obj_course->ProcessingData("InsertPeserta",$params)){
				// uploadfile	
				self::UploadBerkas($berkas,$id);
				// sukses message				
				self::SendNotification($err, $filled, 'Data has been saved.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// filled last field
				$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, "jenis_kelamin" => $this->arr_params['jenis_kelamin'], "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------	
			}
		}else{
			// filled last field
			$filled = array("nama_lengkap" => $this->arr_params['nama_lengkap'], "tempat_lahir" => $this->arr_params['tempat_lahir'], "tanggal_lahir" => $tgl_lahir, "jenis_kelamin" => $this->arr_params['jenis_kelamin'], "prefix" => $this->arr_params['prefix'], "suffix" => $this->arr_params['suffix'], "alamat" => $this->arr_params['alamat'], "kota" => $this->arr_params['kota'], "kodepos" => $this->arr_params['kodepos'], "telepon" => $this->arr_params['telepon'], "no_hp" => $this->arr_params['no_hp'], "agama" => $this->arr_params['agama']);
			// error message
			self::SendNotification($err, $filled, 'See input requirement.', 'error');
			// redirect to page error page --------------------------------	
		}	
		// redirect page --------------------------------------------------		
	}	
	
	
	private function UploadBerkas($berkas,$id){

		$err = array();

		// allowed type

		$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');

		// --

		if(!empty($berkas['tmp_name']) AND $berkas['size'] <= 1000000){

			// name and path file

			$file_name = str_replace(' ', '_', $berkas['name']);

			$file_path = "doc/karya_ilmiah/".$id."/";

			// processing

			if($this->obj_upload->FileUpload($berkas, $file_path)){

				// insert to database

				//$params = array($file_name, $file_path, $id);
				//$this->obj_course->DebugQuery("UpdateFilePath", $params);exit;
				//$this->obj_course->ProcessingData("UpdateFilePath", $params);

				// --

				$err[] = '<br /><strong>'.$file_name.'</strong> berhasil diupload'; 

			}else{

				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 

			}		

		}else{

			$err[] = '<br />Berkas <strong>tidak berhasil</strong> diupload'; 

		}		

		// return

		return $err;

	}
	
	private function ResetSession(){
		$_SESSION['search']['course']['tempat'] =  "";
		$_SESSION['search']['course']['kapasitas'] = "";
		$this->arr_params['tempat'] = "";
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'tersedia');	
	}
}

?>