<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// init object
	protected $obj_data;
	protected $obj_paging;
	protected $obj_date;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load object business "data"
		$this->obj_data = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);	
		// load object pagination
		$this->obj_paging = $this->obj_ctrl->LoadLibrary('PaginationMySQL');
		// load object date time
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('ajaxify', 'jquery');
		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');
		// load style
		$this->obj_ctrl->LoadStyle('popin','otherstyle');
		
	}
	
	public function PageView(){
		// display list
		self::DisplayListData();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayListData(){
		/* 
		-- display paging template (bagian atas)
		*/
		// set parameter pages on index [0]
		if(!isset($this->arr_routes['params'][0]))
			$page = 1;
		else
			$page = $this->arr_routes['params'][0];
		// set active page number
		$this->obj_paging->SetPagesNumber($page);
		// set max record
		$this->obj_paging->SetMaxRecord(20);
		// set total record
		$result = $this->obj_data->GetDataAsSingleArray("GetTotalWillDataCourseByPerson", array($this->str_userid));
		$this->obj_paging->SetTotalRecord($result['total']);
		// set url
		$this->obj_paging->SetUrlPage($this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		// set template
		$this->obj_paging->SetTempatePaging('pagination');
		// parse paging
		$this->obj_paging->ParsePaging();
		/* 
		-- display paging template (bagian bawah)
		*/
		$this->obj_paging->SetTempatePaging('pagination_bottom');
		// parse paging with list
		$this->obj_paging->SetTempateList('list_pagination');
		$this->obj_paging->ParsePagingWithNumber();
		// get start record
		$start = $this->obj_paging->int_start_record;
		$max = $this->obj_paging->int_max_record;
		// parsing data
		$rs_id = $this->obj_data->GetResourceId("GetWillDataCourseByPerson", array($this->str_userid,$start, $max));	
		if($rs_id){
			$no = $start + 1;
			$num = 1;
			while($rs = mysqli_fetch_assoc($rs_id)){
				if($rs['status'] == 'bayar'){
					$stat_byr = '<strong>Sudah melakukan pembayaran</strong>';
				}elseif($rs['status'] == 'booking') {
					$stat_byr = '<strong>Belum membayar</strong>';
				}else{
					$stat_byr = '<strong>Batal</strong>';
				}
				$tgl = explode(" ", self::GetTanggalCourseById($rs['id_course']));
				$tgl = $this->obj_date->GetShortDate('<em>'.$tgl[1])."</em><strong> s/d </b></strong><em> ".$this->obj_date->GetShortDate($tgl[2].'</em>');
				$this->obj_tmpl->addVar('list_data', 'TGL', $tgl);
				
				$this->obj_tmpl->addVar('list_data', 'NO', $num++);
				$this->obj_tmpl->addVar('list_data', 'KOTA', '<strong>'.$rs['city_name'].'</strong><br /><em>'.$rs['province_name'].'</em>');
				$this->obj_tmpl->addVar('list_data', 'TEMPAT', '<strong>'.$rs['tempat'].'</strong><br /><em>'.$rs['alamat'].'</em>');
				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $stat_byr);
				$this->obj_tmpl->addVar('list_data', 'URL_JADWAL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'detail', array($rs['id_course'])));
				$this->obj_tmpl->addVar('list_data', 'URL_DETAIL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'daftar', array($rs['id_course'])));
				$this->obj_tmpl->ParseTemplate('list_data', 'a');
				$no++;
			}
		}
	}
	
	//fungsi get periode tanggal pelatihan
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_data->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
}

?>