<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	// init object
	private $obj_crypt;
	private $obj_course;
	private $obj_date;
	// deklarasi variabel session id_course
	private $str_idcourse;
	private $str_tgl;
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// call function to set page templates
		$this->SetPageTemplates();
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('ajaxify', 'jquery');
		$this->obj_ctrl->LoadJavascript('jquery.popin', 'jquery');
		// themes setting
		// --
		$this->obj_course = $this->obj_ctrl->LoadBusiness('course', 'mysql', $this->arr_config['db']);
		// load crypt function
		$this->obj_crypt = $this->obj_ctrl->LoadLibrary('Cryptograph');
		// load date function
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
		// load style
		$this->obj_ctrl->LoadStyle('popin','otherstyle');
	}
	
	public function PageView(){
		// fungsi display variabel
		self::DisplayVariable();
		// insert data course
		self::InsertDataCourse();
		// fungsi get data 
		self::GetDataPeserta();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	// fungsi display variabel
	private function DisplayVariable(){
		if (isset($_SESSION['id_course']))
			$this->str_idcourse = $_SESSION['id_course'];
		else
			$this->str_idcourse = $this->arr_routes['params'][0];
		$this->obj_tmpl->addVar('pay_guide', 'URL_PAY_GUIDE', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'bayar'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'course'));
	}
	// fungsi set template payment
	private function DisplayTemplateCondition($status){
		if($status == 'booking'){
			$this->obj_tmpl->addVar('pay_guide', 'display', 'no_pay');
		}elseif($status == 'bayar'){
			$this->obj_tmpl->addVar('pay_guide', 'display', 'error');
		}else{
			$this->obj_tmpl->addVar('pay_guide', 'display', 'error');
		}
	}
	// fungsi membuat kode bayar secara dynamic dengan panjang 12 karakter berupa angka
	private function CreatePaymentCode(){
		if(!empty($this->str_idcourse)){
			$rand_1 = mt_rand(1, 1000);
			$rand_2 = mt_rand(1, 500);
			$hash_key1 = $this->obj_crypt->CreateUserKey($rand_1);
			$hash_key2 = $this->obj_crypt->CreateUserKey($rand_2);
			//ambil masing2 6 digit
			$sub_key1 = substr($hash_key1, 0, 6);
			$sub_key2 = substr($hash_key2, 0, 6);
			//menyatukan masing2 sub menjadi 12 digit
			$kode_byr = $sub_key1.$sub_key2;
			return $kode_byr;
		}
	}	
	// fungsi get data peserta
	private function GetDataPeserta(){
		$rs = $this->obj_course->GetDataAsSingleArray("GetDataCourseByPerson", array($this->				
														str_userid, $this->str_idcourse));
		if(!empty($rs)){
				//foto
			$file_photo = "doc/person/".$rs['id_person']."/foto/".$rs['photo'];
			if(is_file($file_photo))
				$this->obj_tmpl->addVar('content', 'PHOTO', HTTPPATH.$file_photo);
			else
				$this->obj_tmpl->addVar('content', 'PHOTO', HTTPPATH."doc/temp/blank.jpg");
			$this->obj_tmpl->addVar('content', 'NAMA_GELAR', $rs['NAMA_GELAR']);
			if($rs['status'] == 'bayar'){
				$stat_byr = '<strong>Sudah melakukan pembayaran</strong>';
			}elseif($rs['status'] == 'booking') {
				$stat_byr = '<strong>Belum membayar</strong>';
			}else{
				$stat_byr = '<strong>Batal</strong>';
			}
			$this->obj_tmpl->addVar('content', 'STATUS', $stat_byr);
			$this->obj_tmpl->addVar('content', 'TGL_BATAS', $this->obj_date->GetFullDate($rs['tgl_jatuh_tempo']));
			$this->obj_tmpl->addVar('content', 'CODE_PAY', $rs['kode_bayar']);
			$this->obj_tmpl->addVar('content', 'PLACE', $rs['tempat']);
			$this->obj_tmpl->addVar('content', 'CITY', $rs['city_name']);
			$this->obj_tmpl->addVar('content', 'PROVINCE', $rs['province_name']);
			$this->obj_tmpl->addVar('content', 'KOOR', $rs['penanggung_jawab']);
			self::DisplayTemplateCondition($rs['status']);
			$tgl = explode(" ", self::GetTanggalCourseById($rs['id_course']));
			$tgl = $this->obj_date->GetFullDate($tgl[1])." - ".$this->obj_date->GetFullDate($tgl[2]);
			$this->obj_tmpl->addVar('content', 'PERIODE', $tgl);
			$this->obj_tmpl->addVar('content', 'URL_JADWAL', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'detail', array($rs['id_course'])));
		}
	}
	//fungsi insert data daftar course
	private function InsertDataCourse(){
		if(!empty($this->str_idcourse)){
			$rs = $this->obj_course->GetDataAsSingleArray("CheckCourseByPerson", 
					array($this->str_userid,$this->str_idcourse));
			if($rs['TOTAL'] == 0){
				// create kode bayar
				$kode_byr = self::CreatePaymentCode();
				$param = array($this->str_userid, $this->str_idcourse, 
							$kode_byr, $this->str_userid);
				if($this->obj_course->ProcessingData('InsertPeserta', $param)){
					unset($_SESSION['id_course']);
				}	
			}
		}
	}
	//fungsi get periode tanggal pelatihan
	private function GetTanggalCourseById($id_course){
		$this->str_tgl = "";
		$rs_id = $this->obj_course->GetResourceId("GetTanggalCourseById", array($id_course, $id_course));
		if($rs_id){
			while($rs = mysqli_fetch_assoc($rs_id)){
				$this->str_tgl = $this->str_tgl.' '.$rs['tanggal'];
			}
		}
		return $this->str_tgl;
	}
}

?>